%global eclipse_dropin %{_datadir}/eclipse/dropins
%global gittag R3_3_1

Name:      eclipse-pdt
Version:   3.3.1
Release:   7%{?dist}
Summary:   PHP Development Tools (PDT) Eclipse plug-in
License:   EPL
URL:       http://www.eclipse.org/pdt/
Source0:   http://git.eclipse.org/c/pdt/org.eclipse.pdt.git/snapshot/org.eclipse.pdt-%{gittag}.tar.bz2

# The lexer/parser code generated by the Fedora version of jflex causes test failures at build time and buggy
# behaviour at runtime so we have pre-generated the parser code using upstream's preferred version of jflex.
# This source tarball was generated with the following commands:
#   $ (cd plugins/org.eclipse.php.core/Resources/parserTools/ && ant)
#   $ tar -czf code_gen.tar.gz $(find -name ParserConstants.java -o -name PhpAstLexer.java -o -name PhpAstParser.java -o -name DocumentorLexer.java -o -name CompilerAstParser.java -o -name CompilerParserConstants.java -o -name CompilerAstParser.java -o -name PHPTokenizer.java -o -name PhpLexer.java)
Source1:   code_gen.tar.gz

# Appdata addon metadata
Source2:   eclipse-pdt.metainfo.xml
Patch0: mars.patch

BuildArch:        noarch

BuildRequires:    eclipse-pde
BuildRequires:    eclipse-tests
BuildRequires:    eclipse-dltk
BuildRequires:    eclipse-dltk-mylyn
BuildRequires:    eclipse-wtp-common
BuildRequires:    eclipse-wtp-sourceediting
BuildRequires:    eclipse-license
BuildRequires:    tycho
BuildRequires:    java_cup >= 0.11a-15
BuildRequires:    xorg-x11-server-Xvfb

Requires:         php
Requires:         php-pecl-xdebug

# Added in F21
Obsoletes:        %{name}-mylyn < %{version}-%{release}
Provides:         %{name}-mylyn = %{version}-%{release}

%description
The PHP IDE project delivers a PHP Integrated Development Environment
framework for the Eclipse platform. This project encompasses the development
components necessary to develop PHP-based Web Applications and facilitates
extensibility. It leverages the existing Web Tools Project in providing
developers with PHP capabilities.

%package   sdk
Summary:   Eclipse PDT SDK
Requires:  eclipse-pde
Requires:  %{name} = %{version}-%{release}
Requires:  %{name}-tests = %{version}-%{release}

%description sdk
Documentation and source for the Eclipse PHP Development Tools (PDT).

%package   tests
Summary:   Eclipse PDT Tests

%description tests
Tests for Eclipse PHP Development Tools (PDT).

%prep
%setup -q -n org.eclipse.pdt-%{gittag}

# Extract pre-generated code
tar xf %{SOURCE1}
%patch0 -p1

# Remove bundled binaries
find -name '*.class' -exec rm -f '{}' \;
find -name '*.jar' -exec rm -f '{}' \;

# Remove plugins not needed
%pom_remove_plugin org.jboss.tools.tycho-plugins:repository-utils dev/org.eclipse.php-repository
%pom_remove_plugin org.eclipse.tycho:tycho-packaging-plugin org.eclipse.pdt.releng
%pom_remove_plugin org.jacoco:jacoco-maven-plugin org.eclipse.pdt.releng
%pom_remove_plugin org.codehaus.mojo:sonar-maven-plugin org.eclipse.pdt.releng

# Skip code generation
%pom_remove_plugin :maven-antrun-plugin plugins/org.eclipse.php.core

# Add java_cup as an OSGi dep instead of bundling
echo "Require-Bundle: java_cup" >> plugins/org.eclipse.php.core.parser/META-INF/MANIFEST.MF

%mvn_package "::jar:sources:" pdt-sdk
%mvn_package ":*.source" pdt-sdk
%mvn_package ":*.{test,tests}" pdt-tests
%mvn_package ":*" pdt

%build
xvfb-run %mvn_build -j -- -f org.eclipse.pdt.releng/pom.xml

%install
%mvn_install

install -D %{SOURCE2} %{buildroot}%{_datadir}/appdata/eclipse-pdt.metainfo.xml

%files -f .mfiles-pdt
%{_datadir}/appdata/eclipse-pdt.metainfo.xml
%doc features/org.eclipse.php-feature/about.html

%files sdk -f .mfiles-pdt-sdk

%files tests -f .mfiles-pdt-tests

%changelog
* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.3.1-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Fri May 8 2015 Alexander Kurtakov <akurtako@redhat.com> 3.3.1-6
- Fix build failure with Mars.

* Thu Sep 25 2014 Mikolaj Izdebski <mizdebsk@redhat.com> - 3.3.1-5
- Rebuild to regenerate auto requires, once again

* Wed Sep 24 2014 Mat Booth <mat.booth@redhat.com> - 3.3.1-4
- Rebuild to regenerate auto requires

* Tue Sep 23 2014 Mat Booth <mat.booth@redhat.com> - 3.3.1-3
- Build/install with xmvn

* Tue Sep 23 2014 Mat Booth <mat.booth@redhat.com> - 3.3.1-2
- Unzip feature bundles on installation
- Add dep on commons-lang
- Add appdata addon metadata
- Drop mylyn sub-package, just install it with main package

* Mon Sep 22 2014 Mat Booth <mat.booth@redhat.com> - 3.3.1-1
- Update to latest upstream
- Drop unneeded patch

* Tue Jun 24 2014 Mat Booth <mat.booth@redhat.com> - 3.3.0-3
- No longer need to copy license feature on F20

* Mon Jun 16 2014 Mat Booth <mat.booth@redhat.com> - 3.3.0-2
- Copy shared license feature, allowing building on F20

* Fri Jun 13 2014 Mat Booth <mat.booth@redhat.com> - 3.3.0-1
- Update to latest release
- Use pre-generated parser code

* Tue Mar 11 2014 Mat Booth <fedora@matbooth.co.uk> - 3.2.0-3.git0be0c838
- Enable tests, run them with a virtual frame buffer

* Mon Feb 10 2014 Mat Booth <fedora@matbooth.co.uk> 3.2.0-2.git0be0c838
- Update to post-release snapshot for PHP 5.5 and Eclipse >= 4.3 support
- Drop upstreamed patch

* Sat Aug 31 2013 Mat Booth <fedora@matbooth.co.uk> 3.2.0-1
- Initial release, based loosely on the eclipse-dltk spec.
